//-----------------------------------------
// LScript Modeler template
//

@version 2.2
@warnings
@script modeler

// global values go here

version=1;
//first finished version

mywiglayer;
myfirstempty;
myguidelayer;
myguidebg;
mysaslite;
mysections;
myhairsurf;
myrootsurf;
myinset;
myminimum;

myworkbg;
myundo=8;
main
{
// Recall values
//debug();
    mywiglayer = recall("MGmywiglayer",5);
    myfirstempty = recall("MGmyfirstempty",true);
    myguidelayer = recall("MGmyguidelayer",2);
    myguidebg = recall("MGmyguidebg",true);
    mysaslite = recall("MGmysaslite",true);
    mysections = recall("MGmysections",10);
    myhairsurf = recall("MGmyhairsurf","hair");
    myrootsurf = recall("MGmyrootsurf","root");
    myinset = recall("MGmyinset",0.01);
    mygroups = recall("MGmygroups",2);
    mysub = recall("MGmysub",1);
    myminimum = recall("MGmyminimum",0.005);

// store old layers

    oldfg=lyrfg();
    oldbg=lyrbg();

// requester code goes here

    reqbegin("WizzyWig by Mike Green. Version"+version);
    reqsize(350,350);
    pagenumber=1;

    t0 = ctltab("Controls","Information","Help");
    c0 = ctlinteger("Wig Layer",mywiglayer);
    c1 = ctlcheckbox("Use first empty layer",myfirstempty);
    c2 = ctlinteger("Guide Layer",myguidelayer);
    c3 = ctlcheckbox("Use background layer curves for guides",myguidebg);
    c5 = ctlcheckbox("Saslite compatibility",mysaslite);
    c4 = ctlinteger("No. of segments",mysections);
    c6 = ctlsurface("Hair Surface",myhairsurf);
    c7 = ctlsurface("Root Surface",myrootsurf);
    c8 = ctldistance("Root inset distance",myinset);
    c9 = ctlinteger("Subdivision Level",mysub);
    c16 = ctlinteger("No. of groups",mygroups);

    c15 = ctldistance("Minimum root distance",myminimum);

    c10 = ctltext("","Email Dodgy@shortbutpurple.fsnet.co.uk");
    ctlposition (c10,50,50);
    c11 = ctltext("1","Place some polygons you want the hair to","grow from in the foreground layer.");
    ctlposition (c11,50,75);
    c12 = ctltext("2","Place some guide curves you want the hair","to grow along in the background layer.");
    ctlposition (c12,50,150);
    c13 = ctltext("3","Press ok and the wig will be grown");
    ctlposition (c13,50,200);

    c17 = ctltext("Wig Layer","The layer the wig be made on.");
    ctlposition (c17,50,50);
    c18 = ctltext("Guide Layer","The Splines along which to grow the hair.");
    ctlposition (c18,50,75);
    c19 = ctltext("Saslite Compatibility","Cap the number of polys to be compliant with saslite.");
    ctlposition (c19,50,100);
    c20 = ctltext("Root Inset","How deep into the head you want the roots.");
    ctlposition (c20,50,125);
    c21 = ctltext("Number Of Groups","If you want multiple clumps in the same layer");
    ctlposition (c21,50,150);
    c22 = ctltext("","this caps the number of polys for all the groups.");
    ctlposition (c22,50,175);


    ctlactive(c1,"toggleon",c0);
    ctlactive(c3,"toggleguideon",c2);
    ctlactive(c5,"saslitecomp",c4);
    ctlpage(1,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c16,c15);
    ctlpage(2,c10,c11,c12,c13);
    ctlpage(3,c17,c18,c19,c20,c21,c22);

    return if !reqpost();


// get requester control values here

    pagenumber = getvalue(t0);
    mywiglayer = getvalue(c0);
    myfirstempty = getvalue(c1);
    myguidelayer = getvalue(c2);
    myguidebg = getvalue(c3);
    mysaslite = getvalue(c5);
    myhairsurf = getvalue(c6);
    myrootsurf = getvalue(c7);
    myinset = getvalue(c8);
    mysub = getvalue(c9);
    myminimum = getvalue(c15);
    mygroups = getvalue(c16);

    reqend();

// Store values for next time

    store("MGmywiglayer",mywiglayer);
    store("MGmyfirstempty",myfirstempty);
    store("MGmyguidelayer",myguidelayer);
    store("MGmyguidebg",myguidebg);
    store("MGmysaslite",mysaslite);
    store("MGmysections",mysections);
    store("MGmyhairsurf",myhairsurf);
    store("MGmyrootsurf",myrootsurf);
    store("MGmyinset",myinset);
    store("MGmysub",mysub);
    store("MGmygroups",mygroups);
    store("MGmyminimum",myminimum);

//-----------------------------------------------------------

//debug();
    selmode(USER);

//findout if faces exist in fg

    tempcount=polycount();       
    if (tempcount[1]==0)
    {
        error("Please select some polygons");
    }
    
    copy(); // copy polys to clipboard

//-----------------------------------------------------------

//find out if rails exist in bg
//debug();

    if (myguidebg)
        if (lyrbg())
        {
            myworkbg=lyrbg();
            myguidelayer=myworkbg[1];
        }
        else
            error("Please select a background layer before running this script");

//Find out if rails exist in bg

    lyrsetfg(myguidelayer);
    selpolygon(CLEAR);
    selpolygon(SET,CURVE); 
    tempcount=polycount();       
    if (tempcount[1]==0)
    {
        lyrsetfg(oldfg);
        lyrsetbg(oldbg);
        error("Please have curves in the background layer");
    }
    if (tempcount[1]>24)
    {   
        lyrsetfg(oldfg);
        lyrsetbg(oldbg);
        error("Please have no more than 24 curves in the background layer (this is a Modeler limitation)");
    }
//-----------------------------------------------------------
// find layer to work in    
    if (myfirstempty)
    {
        temp=lyrempty();
        mywiglayer=temp[1];
    }
    lyrsetfg(mywiglayer);
//debug();
//error("scriptend");

//------------------------------------------------
//UNDOs start here
    myundo=9+mysub; //set undo levels for no metaform, then add 1 for every metaform op.
//debug();
    tempcount=polycount();       
    if (tempcount[1]+pointcount()>0)
    {
        selmode(GLOBAL);
        selhide(SELECTED);
        selmode(USER);

//        delete();
//        myundo++;
    }

    paste();
// Need to find out a scale for next operation. 
    smoothscale(0-myinset);

    temp=1;
    while (temp<=mysub)
    {
        subdivide(METAFORM);
//        myundo++;
        temp++;
    }

    removepols();

    mergepoints(myminimum);

//debug();
// do a check for saslite compatilbility.
    temp=pointcount();
    if (mysaslite and (25000<temp*2))
    {   
        for (i=1;i<=mysub+2;i++)
            undo();
        lyrsetfg(oldfg);
        lyrsetbg(oldbg);
        error ("Too many head polygons to generate guides for saslite. Try using less subdivisions or fewer skull polys."); 
    }



//    cmdseq("Make 1-Point Polygons");
    editbegin();

        mycounter=1;
        while (mycounter != points.size())
        {
            addpolygon(points[mycounter],myrootsurf);
            mycounter++;
        }
    editend();
    copy(); //copy them to the clipboard

//debug();
    lyrsetbg(myguidelayer);

// calculate how many divisions needed. 
    if (mysaslite)
    {
        mycount=polycount();
        temp=(25000-mycount[1])/mycount[1]/mygroups;
        if (temp>30)
            temp=30;
        mysections=temp.asInt();
    }
//error("scriptend");
    railextrude(mysections,KNOTS,"s");
    changesurface(myhairsurf);

//paste back in the root polys
    paste();
    mergepoints();
//copy the whole lot
//debug();
    copy();

//must undo back to the beginning
    for (i=1;i<=myundo;i++)
        undo();

    paste();
    selunhide();

    lyrsetfg(oldfg);
    lyrsetbg(mywiglayer);

// Store any values changed during course of script for next time

    store("MGmywiglayer",mywiglayer);
    store("MGmyfirstempty",myfirstempty);
    store("MGmyguidelayer",myguidelayer);
    store("MGmyguidebg",myguidebg);
    store("MGmysaslite",mysaslite);
    store("MGmysections",mysections);
    store("MGmyhairsurf",myhairsurf);
    store("MGmyrootsurf",myrootsurf);
    store("MGmyinset",myinset);
    store("MGmysub",mysub);
    store("MGmyminimum",myminimum);


}

toggleon : value
{
    if (!value)
//        warn("The layer you select will be deleted before hair is added!!!");
    return(!value);
}

toggleguideon : value
{
    return(!value);
}

saslitecomp: value
{
    return(!value);
}







